<?php
/********************************

Plugin Name: Shortcoder
Plugin URI: http://www.aakashweb.com
Description: Advanced custom shortcode creator plugin. Allows to insert ads,javascripts, flash, HTML within a post using shortcode + Inbuilt useful super shortcodes and sttributes. 
Author: Aakash Chakravarthy
Version: 2.3
Author URI: http://www.aakashweb.com/

***********************************

Copyright 2010  Aakash Chakravarthy  (email : aakash.19493@gmail.com) (website : www.aakashweb.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**********************************

	In short, this plugin is free to use by anyone and everyone. As this plugin is free,
	you can also donate and support this plugin if you like.
	
*********************************/

define('SC_VERSION', '2.3');
define('SC_AUTHOR', 'Aakash Chakravarthy');

if (!defined('WP_CONTENT_URL')) {
	$sc_pluginpath = get_option('siteurl').'/wp-content/plugins/'.plugin_basename(dirname(__FILE__)).'/';
} else {
	$sc_pluginpath = WP_CONTENT_URL . '/plugins/' . plugin_basename(dirname(__FILE__)) . '/';
}

$sc_donate_link = 'https://www.paypal.com/cgi-bin/webscr?cmd=_donations&amp;business=donations@aakashweb.com&amp;item_name=Donation for Shortcoder&amp;amount=&amp;currency_code=USD';

## Load languages
load_plugin_textdomain('sc', false, basename(dirname(__FILE__)) . '/languages/');

## Include files
require_once('shortcoder-inbuilt.php');
require_once('adm-sidebar.php');

## Load the Javascripts
function sc_admin_js() {
	global $sc_pluginpath;
	
	if (isset($_GET['page']) && $_GET['page'] == 'shortcoder/shortcoder.php'){
		wp_enqueue_script('jquery'); 
		wp_enqueue_script('shortcoder-admin-js', $sc_pluginpath . 'sc-admin-js.js', array('jquery'));
		wp_enqueue_script('aw-quick-tag-js', $sc_pluginpath . 'aw-quick-tags/awQuickTag.js', array('jquery', 'shortcoder-admin-js'));
	}
}
add_action('admin_print_scripts', 'sc_admin_js');


## Load the CSS
function sc_admin_css() {
	global $sc_pluginpath;
	
	if (isset($_GET['page']) && $_GET['page'] == 'shortcoder/shortcoder.php') {
		wp_enqueue_style('shortcoder-admin-css', $sc_pluginpath . 'sc-admin-css.css');
		wp_enqueue_style('aw-quick-tag-css', $sc_pluginpath . 'aw-quick-tags/awQuickTag.css'); 
	}
}
add_action('admin_print_styles', 'sc_admin_css');

## Basic functions ##
function shortcoder_page_check($name){

	$sc_options = get_option('shortcoder_data');
	
	if (is_home() == 1 && $sc_options['sc_is_front_page'][$name] != 1){
		return true;
		
	}elseif (is_single() == 1 && $sc_options['sc_is_single'][$name] != 1){
		return true;
		
	}elseif (is_page() == 1 && $sc_options['sc_is_page'][$name] != 1){
		return true;
		
	}elseif (is_archive() == 1 && $sc_options['sc_is_archive'][$name] != 1){
		return true;
	
	}elseif (is_tag() == 1 && $sc_options['sc_is_archive'][$name] != 1){
		return true;
		
	}elseif(is_search() == 1 && $sc_options['sc_is_search'][$name] != 1){
		return true;
		
	}else{
		return false;
	}
}

function shortcoder_user_check($name){

	$sc_options = get_option('shortcoder_data');
	
	if(current_user_can('level_10') && $sc_options['sc_is_admin'][$name] == 1){
		return false;
	}else{
		return true;
	}
}

## Main function
function shortcoder($atts, $content) { 
	
	## Globals
	global $sc_pluginpath, $sc_donate_link;
	
	$sc_options = get_option('shortcoder_data');
	static $sc_added_count;
	
	## Extracting the attributes used in the shortcode
	 extract(shortcode_atts(array(
		 "name" => "default", "width" => "", "height" => "", "id" => "", 
		 "type" => "", "href" => "", "value" => "", 
		 "class" => "", "style" => "", "title" => "", 
		 "onclick" => "", "ondblclick" => "", "onmouseover" => "", 
		 "onmouseout" => "", "onmouseup" => "", "src" => "", 
		 "alt" => "", "allowscriptaccess" => "", "wmode" => "", 
		 "data" => "", "flashvars" => "", "movie" => "", 
		 "url" => "", "bgcolor" => "", "misc1" => "", 
		 "misc2" => "", "misc3" => ""
	 ), $atts)); 
 
 	## List the strings to be replaced
	$sc_replace_strings = array(
		 "", $width, $height,
		 $id, $type, $href,
		 $value, $class, $style,
		 $title, $onclick, $ondblclick,
		 $onmouseover, $onmouseout, $onmouseup, 
		 $src, $alt, $allowscriptaccess, 
		 $wmode, $data, $flashvars, 
		 $movie ,$url ,$bgcolor, 
		 $misc1, $misc2, $misc3
	 );
	 
	 $sc_replaceable = array(
		 "%%%%%", "%width%", "%height%", 
		 "%id%", "%type%", "%href%", 
		 "%value%", "%class%", "%style%", 
		 "%title%", "%onclick%", "%ondblclick%", 
		 "%onmouseover%", "%onmouseout%", "%onmouseup%", 
		 "%src%", "%alt%", "%allowscriptaccess%", 
		 "%wmode%", "%data%", "%flashvars%", 
		 "%movie%", "%url%", "%bgcolor%", 
		 "%misc1%", "%misc2%","%misc3%"
	 );
	 

	if(isset($sc_options['sc_content'][$name])){
	
		## Check whether the shortcode attribute is disabled or not
		if ($sc_options['sc_disable'][$name] == "true"){
			  return do_shortcode($content);
		 }else{
			 $sc_replaced =  $sc_options['sc_content'][$name] . do_shortcode($content);
			 $sc_processed = str_replace($sc_replaceable, $sc_replace_strings , $sc_replaced);
			 ++$sc_added_count; 
			 
			 if(shortcoder_page_check($name) == true && shortcoder_user_check($name) == true){
				return "\n<!-- Start of #$sc_added_count shortcode -->\n" . $sc_processed . "\n<!-- End of #$sc_added_count shortcode -->\n";
			 }else{
				return "\n<!-- #$sc_added_count shortcode (Disabled) --><!-- End #$sc_added_count shortcode -->\n";
			 }
			 
		 }
	 }else{
	 	return "\n<!--  Shortcode (No content/Not exists) -->\n";
	 }
}

function shortcoder_footer(){
	echo "\n<!-- Shortcodes in this website are added by shortcoder wordpress plugin | www.aakashweb.com -->\n";
}

function sc_addpage() {
    add_submenu_page('options-general.php', 'Shortcoder', 'Shortcoder', 10, __FILE__, 'sc_admin_page');
}
#### End basic functions ####


## Actions
add_shortcode('sc', 'shortcoder');
add_action('wp_footer', 'shortcoder_footer');
add_action('admin_menu', 'sc_addpage');

#### Shortcoder admin page ####
function sc_admin_page(){
	## Globals
	global $sc_pluginpath, $sc_donate_link;
	
	## Shortcoder admin page
	$sc_updated = false;
    $sc_options = get_option('shortcoder_data');
	
	$sc_id_no = $_GET['sc_id_no'];
    if ($sc_id_no == ''){
		$sc_id_no = 1;
	}

	## Main admin page form
	if ($_POST["sc_submit"] && $_POST["sc_form_main"] == '1' ) {
	
		$sc_new_name = $_POST['sc_name'];
		$sc_old_name = $sc_options[$sc_id_no]['sc_name'];
		
		## Deleting unused old arrays
		if($sc_old_name != $sc_new_name){
			unset(
				$sc_options['sc_content'][$sc_old_name],
				$sc_options['sc_disable'][$sc_old_name],
				$sc_options['sc_is_front_page'][$sc_old_name],
				$sc_options['sc_is_single'][$sc_old_name],
				$sc_options['sc_is_page'][$sc_old_name],
				$sc_options['sc_is_archive'][$sc_old_name],
				$sc_options['sc_is_tag'][$sc_old_name],
				$sc_options['sc_is_search'][$sc_old_name],
				$sc_options['sc_is_admin'][$sc_old_name]
			);
		}
		
		## Getting the posted datas
		$sc_options[$sc_id_no]['sc_name'] = $sc_new_name;
		$sc_options['sc_content'][$sc_new_name] = stripslashes($_POST['sc_content']);
		
		$sc_options['sc_disable'][$sc_new_name] = $_POST['sc_disable'];
		$sc_options['sc_is_front_page'][$sc_new_name] = $_POST['sc_is_front_page'];
		$sc_options['sc_is_single'][$sc_new_name] = $_POST['sc_is_single'];
		$sc_options['sc_is_page'][$sc_new_name] = $_POST['sc_is_page'];
		$sc_options['sc_is_archive'][$sc_new_name] = $_POST['sc_is_archive'];
		$sc_options['sc_is_tag'][$sc_new_name] = $_POST['sc_is_tag'];
		$sc_options['sc_is_search'][$sc_new_name] = $_POST['sc_is_search'];
		
		$sc_options['sc_is_admin'][$sc_new_name] = $_POST['sc_is_admin'];
		
		## Updating the DB
		update_option("shortcoder_data", $sc_options);
		$sc_updated = true;
		
		## Updated Message
		if($sc_updated == 'true'){
			echo '<div class="message updated fade"><p>' . __('Updated successfully.', 'sc') . '</p></div>';
		}else{
			echo '<div class="message error fade"><p>' . __('Unable to update !', 'sc') . '</p></div>';
		}

	}

	## Retrieve and assign the new data to variables
	$sc_name = $sc_options[$sc_id_no]['sc_name'];
	$sc_content = stripslashes($sc_options['sc_content'][$sc_name]);

	$sc_disable = $sc_options['sc_disable'][$sc_name];
	$sc_is_front_page = $sc_options['sc_is_front_page'][$sc_name];
	$sc_is_single = $sc_options['sc_is_single'][$sc_name];
	$sc_is_page = $sc_options['sc_is_page'][$sc_name];
	$sc_is_archive = $sc_options['sc_is_archive'][$sc_name];
	$sc_is_search = $sc_options['sc_is_search'][$sc_name];
	
	$sc_is_admin = $sc_options['sc_is_admin'][$sc_name];
	
	if($sc_name == ''){
		$sc_submit_disable = ' disabled=disabled';
	}
?>

<!-- Shortcoder Admin page --> 

<div class="wrap">
<h2><img width="32" height="32" src="<?php echo $sc_pluginpath; ?>images/shortcoder.png" align="absmiddle"/>&nbsp;Shortcoder<span class="smallText"> v<?php echo SC_VERSION; ?></span></h2>

<div id="leftContent">
<form method="post">
	<div class="content">
	<h4><?php _e('Select a shortcode', 'sc'); ?></h4>
	<div class="section">
     <table width="100%" height="45" border="0">
       <tr>
         <td width="173"><label for="sc_id"><?php _e('Shortcode Name', 'sc'); ?></label> </td>
         <td width="775">
		 <select id="sc_id" name="sc_id" value="<?php  echo $sc_id=$_GET['sc_id_no']; ?>">
           <?php for($listid=1;$listid < 21;$listid++){
	   echo "<option value='$listid' ".($listid == $sc_id_no ? "selected='selected'" : '').">"?>
           <?php echo " ".$listid ." - ". $sc_options[$listid]['sc_name'];"</option>"; }?>
         </select><br />
         <span class="smallText"><?php _e('Select the Shortcode Attribute to be edited', 'sc'); ?></span></td>
         </tr>
     </table>
	 </div>
   
	<h4><?php _e('Properties', 'sc'); ?></h4>
	<div class="section">
	 <table width="100%" height="348" border="0">
	   <tr>
		 <td width="174" height="43"><label for="sc_name"><?php _e('Name', 'sc'); ?></label> </td>
		 <td width="774"><input name="sc_name" type="text" id="sc_name" value="<?php echo $sc_name; ?>" size="60" /><br />
		 <span class="smallText"><?php echo sprintf(__('Edit the attribute name. This is used as [sc name="<b>%s</b>"]', 'sc'), $sc_name); ?></span></td>
	   </tr>
	   <tr>
	     <td height="41"><?php _e('Content:', 'sc'); ?></td>
	     <td>&nbsp;</td>
	     </tr>
	   <tr>
	     <td height="256" colspan="2">
		<?php include_once('aw-quick-tags/toolbar.php');?>
		<textarea  name="sc_content" rows="10" id="sc_content"><?php echo $sc_content; ?></textarea><br />
		 <span class="smallText">
		 <?php echo sprintf( __('Enter any Javascript / HTML / Flash embed code or Plain text. This is the output got when the shortcode [sc name="%s"] is used in your post.', 'sc'), $sc_name); ?>
		 </span>
		</td>
	     </tr>
	 </table>
	 </div>
	<h4><?php _e('Optional Settings', 'sc'); ?></h4>
	<div class="section">
		 <table width="100%" height="45" border="0">
		   <tr>
			 <td width="208"><label for="sc_disable"><?php _e('Disable this shortcode', 'sc'); ?></label></td>
			 <td width="740">
			   <input name="sc_disable" type="checkbox" id="sc_disable" value="true" <?php echo $sc_disable == "true" ? 'checked="checked"' : ""; ?>  />
			 <span class="smallText"><?php _e('Checking this checkbox will not display anything when this shortcode attribute is used.', 'sc'); ?></span></td>
		   </tr>
		 </table>
		 
		 <div class="alignleft optionalOptions" style="width:48%">
		 <p><?php _e('Do not execute this shortcode in :', 'sc'); ?></p>
		 
		<label><input name="sc_is_front_page" type="checkbox" id="sc_is_front_page" value="1" <?php echo $sc_is_front_page == "1" ? 'checked="checked"' : ""; ?> /> <?php _e('Home page', 'sc'); ?></label><br />
		
		<label><input name="sc_is_single" type="checkbox" id="sc_is_single" value="1" <?php echo $sc_is_single == "1" ? 'checked="checked"' : ""; ?>> <?php _e('Post pages', 'sc'); ?></label><br />
		
		<label><input name="sc_is_page" type="checkbox" id="sc_is_page" value="1" <?php echo $sc_is_page == "1" ? 'checked="checked"' : ""; ?>> <?php _e('Page', 'sc'); ?></label><br />
		
		<label><input name="sc_is_archive" type="checkbox" id="sc_is_archive" value="1" <?php echo $sc_is_archive == "1" ? 'checked="checked"' : ""; ?>> <?php _e('Archive or Tag pages', 'sc'); ?></label><br />

		  <label><input name="sc_is_search" type="checkbox" id="sc_is_search" value="1" <?php echo $sc_is_search == "1" ? 'checked="checked"' : ""; ?>> <?php _e('Search results page', 'sc'); ?></label>
		  
	</div>
	
	
	<div class="alignleft optionalOptions">
	<p><?php _e('Do not show this shortcode to :', 'sc'); ?></p>
	
	<label><input name="sc_is_admin" type="checkbox" id="sc_is_admin" value="1" <?php echo $sc_is_admin == "1" ? 'checked="checked"' : ""; ?> /> <?php _e('Administrator', 'sc'); ?></label><br />
	
	</div>
	
	<div style="clear:both"></div>
	</div>
	
	<input name="sc_form_main" type="hidden" value="1" />
	<input class="button-primary" type="submit" name="sc_submit" id="sc_submit" <?php echo $sc_submit_disable; ?> value="     <?php _e('Update', 'sc'); ?>     " />
	</div>
	
	<br />
	
	<div class="content">
		<h4><?php _e('Preview', 'sc'); ?></h4>
		<div class="section">
			<?php echo stripslashes($sc_options['sc_content'][$sc_name]); ?>
		</div>
	</div>
	
</form>

</div>

<?php sc_admin_sidebar(); ?>
<!-- Sidebar -->
</div>

<script type="text/javascript">
	var sc_id = document.getElementById('sc_id'); 
	sc_id.onchange = function() {
		location.href = '<?php echo get_option('home'); ?>/wp-admin/options-general.php?page=shortcoder/shortcoder.php&sc_id_no='+sc_id.value;
	}
	
	var sc_name = document.getElementById('sc_name');
	var sc_submit = document.getElementById('sc_submit');
	sc_name.onchange = function(){
		if(sc_name.value == ''){
			sc_submit.disabled = "disabled";
		}else{
			sc_submit.disabled = "";
		}
	}
</script>

<?php 
}
?>